<!doctype html>
<html lang="es">

<head>
  <meta charset='utf-8'>
  <title>Diseño Adaptativo</title>
  <link rel='stylesheet' href='css/style.css'>
  <link rel='stylesheet' href='css/print.css' media='print'>
</head>

<body>


  <article class='reveal'>

    <section data-bespoke-state='portada'>
      <h1>Diseño Adaptativo</h1>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Introducción</h2>
      <ul class="lista">
        <li><i>Responsive Design</i></li>
        <li>Diseñar con distintos dispositivos en mente</li>
        <li>Decidir prioridad: Escritorio o móvil</li>
        <li>Usar unidades relativas, máximos y mínimos</li>
      </ul>
      <h3><a href="https://mediaqueri.es/">Ejemplos</a></h3>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Viewport</h2>
      <pre><code><span class="etiqueta">meta <span class="propiedad">name=</span><span class="valor">"viewport"</span> <span class="propiedad">content=</span><span class="valor">"initial-scale=1, width=device-width"</span></span></code></pre>
      <ul class="lista">
        <li>Meter en la parte del <span class="etiqueta">head</span> en páginas responsive</li>
        <li><span class="propiedad">name=</span><span class="valor">"viewport"</span>, afecta al <i>viewport</i> (región visible del navegador)</li>
        <li><span class="propiedad">content=</span><span class="valor">"initial-scale=1, width=device-width"</span>
          <ul>
            <li><span class="valor">initial-scale=1</span>, indica el zoom con el que se carga la página<br>
              Evita problemas al cambiar de orientación</li>
            <li><span class="valor">width=device-width</span>, indica el ancho del <i>viewport</i><br>
              De no indicarlo, elige el navegador y luego hace un zoom</li>
          </ul>
        </li>
      </ul>
    </section>


    <section data-bespoke-state='clean'>
      <h2>Media queries</h2>
      <ul class="lista">
        <li>Permiten aplicar distintos estilos dependiendo de:
          <ul>
            <li>Tipo de dispositivo</li>
            <li>Condiciones</li>
          </ul>
        </li>
      </ul>
      <h3>Cómo aplicarlas</h3>
      <p class="importante">En HTML, con etiqueta <span class="etiqueta">link</span>:</p>
      <pre><code><span class="etiqueta">link <span class="propiedad">rel=</span><span class="valor">"stylesheet"</span> <span class="propiedad">media=</span><span class="valor">"condiciones"</span> <span class="propiedad">href=</span><span class="valor">"url.css"</span></span></code></pre>
      <p class="importante">En CSS, con la instrucción <span class="arroba-css">@media</span></p>
      <pre><code><span class="arroba-css">@media</span> <span class="media">condiciones</span> { estilos... }</code></pre>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Tipos de dispositivos</h2>
      <ul class="lista">
        <li><span class="valor"><strong>all</strong></span>, a todos (por defecto)</li>
        <li><span class="valor">screen</span>, a las pantallas</li>
        <li><span class="valor">print</span>, para impresión</li>
      </ul>
      <h3>Ejemplos:</h3>

      <div class="columnas-flex">
        <div>
          <h4>index.html</h4>
          <pre><code><span class="etiqueta">link <span class="propiedad">rel=</span><span class="valor">"stylesheet"</span> <span class="propiedad">media=</span><span class="valor">"print"</span> <span class="propiedad">href=</span><span class="valor">"css/imprimir.css"</span></span></code></pre>
        </div>
        <div>
          <h4>css/imprimir.css</h4>
          <pre><code><span class="selector">img</span> { <span class="propiedad">display:</span> <span class="valor-css">none;</span> }</code></pre>
        </div>
      </div>
      <hr style="margin: 1em;">
      <h4>css/estilo.css</h4>
      <pre><code><span class="arroba-css">@media</span> <span class="media">print</span> { 
  <span class="selector">img</span> { <span class="propiedad">display:</span> <span class="valor-css">none;</span> }
}</code></pre>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Condiciones</h2>
      <ul class="lista">
        <li><span class="valor">width</span>, ancho de la pantalla (admite min y max)</li>
        <li><span class="valor">height</span>, alto de la pantalla (admite min y max)</li>
        <li><span class="valor">orientation</span>, orientación de la pantalla (<span class="valor-css">landscape</span> o <span class="valor-css">portrait</span>)</li>
        <li><span class="valor">aspect-ratio</span>, proporción entre altura y anchura</li>
        <li><span class="valor">resolution</span>, densidad de píxeles</li>
        <li><span class="valor">color</span>, si el dispositivo admite colores</li>
      </ul>
      <h3>Las más usadas</h3>
      <ul class="lista">
        <li><span class="valor">min-width</span>, la pantalla tiene que tener valor mayor</li>
        <li><span class="valor">max-width</span>, la pantalla tiene que tener valor menor</li>
      </ul>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Combinar condiciones</h2>
      <ul class="lista">
        <li><span class="valor">and</span> para que cumplan todas (y)</li>
        <li><span class="valor">,</span> para que cumpla alguna (o)</li>
        <li><span class="valor">not</span> niega la condición</li>
      </ul>
      <h3>Ejemplos</h3>
      <pre><code><span class="arroba-css">@media</span> <span class="media">screen and (max-width: 575.98px)</span> { ... }        
<span class="arroba-css">@media</span> <span class="media">screen and (min-width: 640px) and (max-width: 1280px)</span> { ... }
<span class="arroba-css">@media</span> <span class="media">(min-width: 700px), screen and (orientation: landscape)</span> { ... }
<span class="arroba-css">@media</span> <span class="media">(not(color))</span> { ... }</code></pre>
    </section>

    <section data-bespoke-state='clean'>
      <h2>Recomendación</h2>
      <ul class="lista">
        <li>Usar los rangos según tu contenido</li>
      </ul>
      <h3>Ejemplo 'saltos' de Bootstrap</h3>
      <pre><code>/* Muy pequeños */
<span class="arroba-css">@media</span> <span class="media">screen and (max-width: 575.98px)</span> { ... }

/* Pequeños */
<span class="arroba-css">@media</span> <span class="media">screen and (min-width: 576px) and (max-width: 767.98px)</span> { ... }

/* Dispositivos medianos */
<span class="arroba-css">@media</span> <span class="media">screen and (min-width: 768px) and (max-width: 991.98px)</span> { ... }

/* Largos */
<span class="arroba-css">@media</span> <span class="media">screen and (min-width: 992px) and (max-width: 1199.98px)</span> { ... }

/* Extra largos */
<span class="arroba-css">@media</span> <span class="media">screen and (min-width: 1200px)</span> { ... }</code></pre>
    </section>

    <section data-bespoke-state='clean'>      
      <h3><a href="ejemplos/p19_responsive.html" target="_blank">Ejemplo</a></h3>
      <iframe src="ejemplos/p19_responsive.html" style="width: 800px;height: 400px;"></iframe>
    </section>

    <section class="pt-05 no-print" data-bespoke-state='clean'>
      <h2>Ejercicio</h2>
      <ul class="lista">
        <li>Ajustar los estilos para que se vea bien en todas las anchuras de pantalla</li>
        <li>En anchura media:
          <ul>
            <li>Ampliar la altura de la cabecera</li>
            <li>Adaptar el padding de los enlaces del menú</li>
            <li>Hacer que la receta ocupe todo el ancho de la pantalla</li>
          </ul>
        </li>
        <li>En anchura pequeña:
          <ul>
            <li><span class="etiqueta">h1</span>, quitar el margen superior y aplicar un paddin superior</li>
            <li>Cambiar la altura de la cabecera a <span class="valor-css">auto</span></li>
            <li>Poner la imagen de la cabecera como bloque de linea y una altura de <span class="valor-css">50px</span></li>
            <li>Pasar el menú a posición estática y <br>
              mostrar tanto los <span class="etiqueta">li</span>, como los enlaces como bloques</li>
            <li>Hacer que las secciones de resultado e ingredientes ocupen todo el ancho</li>
          </ul>
        </li>
      </ul>
      <p class="text-center">
        <span style="font-weight: bold;">Inicio:</span>
        <a href="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio34/index.html?inline=false">index</a>
        <a href="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio34/css/estilo.css?inline=false">estilo</a>
        <span style="font-weight: bold;">Resultados:</span>
        <a href="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio34/img/resultado_grande.png?inline=false">grande</a>
        <a href="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio34/img/resultado_intermedio.png?inline=false">intermedio</a>
        <a href="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio34/img/resultado_peque.png?inline=false">pequeño</a>
      </p>
    </section>

    <section class="pt-05 no-print" data-bespoke-state='clean'>
      <h2>Ejercicio</h2>
      <ul class="lista">
        <li>Partiendo del ejercicio anterior</li>
        <li>Añadir un botón en la parte superior derecha</li>
        <li>El botón solo se tiene que ver en pantallas pequeñas</li>
        <li>Al pulsarlo tiene que mostrar el menú</li>
        <li>Al volver a pulsar tiene que ocultarlo</li>
      </ul>
      <p>
        <span style="font-weight: bold;">Resultados:</span>
        <a href="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio34/img/resultado_peque_boton.png?inline=false">botón</a>
        <a href="https://gitlab.com/Material_Formacion/html-y-css/ejercicios/-/raw/master/ejercicio34/img/resultado_peque_boton_desplegado.png?inline=false">botón desplegado</a>
      </p>
    </section>

  </article>

  <script src='js/slides.keys.js'></script>
  <script src='js/slides.classes.js'></script>
  <script src='js/slides.state.js'></script>
  <script src='js/slides.kernel.js'></script>
  <script src='js/slides.jump.js'></script>
  <script src='js/slides.swipe.js'></script>

  <script>
    const { Deck, classes, keys, state, jump, swipe } = S6;
    const deck = new Deck({
      parent: 'article',
      plugins: [classes(), keys(), state(), jump(), swipe()]
    });
  </script>
</body>

</html>